-- debug functions
function cdalarm_print_variable(variable, variablename)
	print(variablename..": "..cdalarm_convert_to_string(variable, ""))
end

function cdalarm_convert_to_string(variable, tabledimension)
	local returnvalue = ""
	local variabletype = type(variable)
	if variabletype == "nil" then returnvalue = "|CFF0000FFnil|r"
	elseif variabletype == "number" 	then returnvalue = "'"..variable.."'"
	elseif variabletype == "string" 	then returnvalue = "'"..variable.."'"
	elseif variabletype == "boolean" 	then returnvalue = cdalarm_convert_boolean_to_string(variable)
	elseif variabletype == "table" 		then returnvalue = cdalarm_convert_table_to_string(variable, tabledimension)
	else returnvalue = "unknown variabletype" end
	return returnvalue
end

function cdalarm_convert_table_to_string(variable, tabledimension)
	local returnvalue = ""
	local newtabledimension = ""
	for i=1, #variable do
		newtabledimension = tabledimension.."["..i.."]"
		if type(variable[i]) == "table" then returnvalue = returnvalue.." "..cdalarm_convert_to_string(variable[i], newtabledimension)
		else returnvalue = returnvalue.." |CFF00FF00"..newtabledimension.."|r "..cdalarm_convert_to_string(variable[i], newtabledimension) end
	end
	returnvalue = returnvalue .. " "
	return returnvalue
end

function cdalarm_convert_boolean_to_string(variable)
	if variable then return "|CFF0000FFtrue|r"
	else return "|CFF0000FFfalse|r" end
end