function cdalarm.panel_msgs()
	return {
		type = "group",
		order= 1,
		args = {
			textfont = {
				name = "Text font",
				order=11, type = "select",
				dialogControl = "LSM30_Font",
				desc = "Sets the font for the messages",
				values = cdalarm.LSM:HashTable("font"),
				set = function(self,key) cdalarm_frame_font=key end,
				get = function() return cdalarm_frame_font end,
				},
			textsize = {
				name = "Text Size",
				order=12, type = "range",
				desc = "Sets the font size for the messages",
				step = 1, min = 6, max = 20,
				set = function(info,val) cdalarm_frame_fontsize=val end,
				get = function() return cdalarm_frame_fontsize end,
				},
			fontalign = {
				name = "Font align:",
				order=13, type = "select", style = "dropdown",
				desc = "Sets sound channel that is used to play the sound",
				values = {["LEFT"]="Left", ["CENTER"]="Center", ["RIGHT"]="Right"},
				set = function(self,key) cdalarm_frame_font_align=key end,
				get = function() return cdalarm_frame_font_align end,
				},
			alarm_timeheader1 = {name = "\n", type = "description", order=14},
			alarm_timeheader2 = {name = "\n", type = "description", order=17},
			alarmshowtime = {
				name = "Duration: message",
				order=18, type = "range",
				desc = "How long events are shown before they fade out",
				step = 1, min = 1, max = 10,
				set = function(info,val) cdalarm_showtime=val end,
				get = function() return cdalarm_showtime end,
				},
			alarmvanishtime = {
				name = "Duration: fade-out effect",
				order=19, type = "range",
				desc = "How long events are fading out",
				step = 1, min = 1, max = 10,
				set = function(info,val) cdalarm_vanishtime=val end,
				get = function() return cdalarm_vanishtime end,
				},
			allowvanish = {
				name = "Allow Fade-Out-Effect",
				order=20, type = "toggle",
				desc = "Enabling this lets the events fade out",
				set = function(info,val) cdalarm_proclaim_vanish=val end,
				get = function() return cdalarm_proclaim_vanish end,
				},
			frame_textspace = {name ="\n", type = "description", order=21},
			alarmcount = {
				name = "Maximum shown events",
				order=22, type = "range",
				desc = "Sets the amount of maximum shown messages",
				step = 1, min = 1, max = 20,
				set = function(info,val) cdalarm_max_events=val end,
				get = function() return cdalarm_max_events end,
				},
			frame_textspace2 = {name ="\n", type = "description", order=24},
			alarmx = {
				name = "X-Ordinate",
				order=25, type = "range",
				desc = "Distance from the left part of the frame to the message",
				step = 1, min = 1, max = 100,
				set = function(info,val) cdalarm_frame_proclaim_xvalue=val end,
				get = function() return cdalarm_frame_proclaim_xvalue end,
				},
			alarmy = {
				name = "Y-ordinate",
				order=26, type = "range",
				desc = "Distance from the top part of the frame to the message",
				step = 1, min = -100, max = 0,
				set = function(info,val) cdalarm_frame_proclaim_yvalue=val end,
				get = function() return cdalarm_frame_proclaim_yvalue end,
				},
			alarmspacing = {
				name = "Distance between the events",
				order=27, type = "range",
				desc = "Sets the space between the events",
				step = 1, min = 1, max = 100,
				set = function(info,val) cdalarm_frame_proclaim_spacing=val end,
				get = function() return cdalarm_frame_proclaim_spacing end,
				},
			moveupspace1 = {name ="\n\n", type = "description", order=120},
			moveupheader = {name ="DEIR-mode", type = "header", order=121},
			moveuptext = {name ="In 'DEIR'-mode (Dead Events in Idle Rotatestate) the events don't move up anymore when an event-message which is displayed above them expired. They stay at their location where they are first shown. In the DEIR-mode the adjustment for maximum shown events isn't active anymore.", type = "description", order=123, fontSize="medium"},
			allowmoveup = {
				name = "Activate DEIR-mode",
				order=123, type = "toggle", width="full",
				desc = "Events that are faded out make place for other events",
				set = function(info,val) if val then cdalarm_frame_allow_scrolling=false else cdalarm_frame_allow_scrolling=true end end,
				get = function() return not(cdalarm_frame_allow_scrolling) end,
				},
			moveupspace3 = {name ="\n", type = "description", order=124},
			

					

			
			
			
			messagetemplate = {name = "parse information code", type="header", order=125},
			header = {name = "You can use the following tags to parse information in the messages\n\nCastername:\n|CFFFF7D0A{caster}|r uncolored, |CFFFF7D0A{caster_sc}|r specific colored, |CFFFF7D0A{caster_cc}|r classcolored\n\ntargetname:\n|CFFFF7D0A{target}|r uncolored, |CFFFF7D0A{target_sc}|r specific colored, |CFFFF7D0A{target_cc}|r classcolored\n\nspellname:\n|CFFFF7D0A{spell}|r uncolored, |CFFFF7D0A{spell_sc}|r specific colred, |CFFFF7D0A{spell_cc}|r classcolored\n\nstatus:\n|CFFFF7D0A{status}|r uncolored, |CFFFF7D0A{status_c}|r specific colored",
				type = "description", order=126, fontSize="medium"},
				
			messagetemplate_color = {name = "parse information colors", type="header", order=150},
			statuscolor1 = {
				name = "{status_sc} active",
				order=151, type = "color", width="",
				desc = "Color for the status text when a buff/spell becomes active",
				set = function(info,r,g,b) cdalarm_proclaim_text_status_color[1][1] = cdalarm_dec2hex(r,g,b) cdalarm_proclaim_text_status_color[1][2]=r cdalarm_proclaim_text_status_color[1][3]=g cdalarm_proclaim_text_status_color[1][4]=b end,
				get = function() return cdalarm_proclaim_text_status_color[1][2],cdalarm_proclaim_text_status_color[1][3],cdalarm_proclaim_text_status_color[1][4] end,
				},
			statusmsgcolor1 = {
				name = "text color for buff gained/cast succeded",
				order=152, type = "color", width="double",
				desc = "color for the message text when spell is cast or a buff is gained",
				set = function(info,r,g,b,a) cdalarm_text_color[1][1]=r cdalarm_text_color[1][2]=g cdalarm_text_color[1][3]=b cdalarm_text_color[1][4]=a end,
				get = function() return cdalarm_text_color[1][1],cdalarm_text_color[1][2],cdalarm_text_color[1][3],cdalarm_text_color[1][4] end,
				},
			statuscolor2 = {
				name = "{status_sc} inactive",
				order=153, type = "color", width="",
				desc = "Color for the status text when a buff/spell becomes inactive",
				set = function(info,r,g,b) cdalarm_proclaim_text_status_color[2][1] = cdalarm_dec2hex(r,g,b) cdalarm_proclaim_text_status_color[2][2]=r cdalarm_proclaim_text_status_color[2][3]=g cdalarm_proclaim_text_status_color[2][4]=b end,
				get = function() return cdalarm_proclaim_text_status_color[2][2],cdalarm_proclaim_text_status_color[2][3],cdalarm_proclaim_text_status_color[2][4] end,
				},
			statusmsgcolor2 = {
				name = "text color for buff lost",
				order=154, type = "color", width="double",
				desc = "color for the message text when a buff is lost",
				set = function(info,r,g,b,a) cdalarm_text_color[2][1]=r cdalarm_text_color[2][2]=g cdalarm_text_color[2][3]=b cdalarm_text_color[2][4]=a end,
				get = function() return cdalarm_text_color[2][1],cdalarm_text_color[2][2],cdalarm_text_color[2][3],cdalarm_text_color[2][4] end,
				},
			frame_textspace3 = {name ="\n\n", type = "description", order=155},
			
			castercolor = {
				name = "{caster_sc}",
				order=161, type = "color", width="full",
				desc = "Color for the caster, when the messages contains {caster_sc}",
				set = function(info,r,g,b) cdalarm_proclaim_constant_colors[1][1] = cdalarm_dec2hex(r,g,b) cdalarm_proclaim_constant_colors[1][2]=r cdalarm_proclaim_constant_colors[1][3]=g cdalarm_proclaim_constant_colors[1][4]=b end,
				get = function() return cdalarm_proclaim_constant_colors[1][2],cdalarm_proclaim_constant_colors[1][3],cdalarm_proclaim_constant_colors[1][4] end,
				},
			targetcolor = {
				name = "{target_sc}",
				order=162, type = "color", width="full",
				desc = "Color for the target, when the messages contains {target_sc}",
				set = function(info,r,g,b) cdalarm_proclaim_constant_colors[2][1] = cdalarm_dec2hex(r,g,b) cdalarm_proclaim_constant_colors[2][2]=r cdalarm_proclaim_constant_colors[2][3]=g cdalarm_proclaim_constant_colors[2][4]=b end,
				get = function() return cdalarm_proclaim_constant_colors[2][2],cdalarm_proclaim_constant_colors[2][3],cdalarm_proclaim_constant_colors[2][4] end,
				},
			spellcolor = {
				name = "{spell_sc}",
				order=163, type = "color", width="full",
				desc = "Color for the spellname, when the messages contains {spell_sc}",
				set = function(info,r,g,b) cdalarm_proclaim_constant_colors[3][1] = cdalarm_dec2hex(r,g,b) cdalarm_proclaim_constant_colors[3][2]=r cdalarm_proclaim_constant_colors[3][3]=g cdalarm_proclaim_constant_colors[3][4]=b end,
				get = function() return cdalarm_proclaim_constant_colors[3][2],cdalarm_proclaim_constant_colors[3][3],cdalarm_proclaim_constant_colors[3][4] end,
				},
				
				
				
				
				
				
			buffheader = {name = "Buffs", type="header", order=1130},
			buff = {
				name = "active message",
				desc = "this message is shown when a buff becomes active",
				order=1131, type = "input", multiline = false,
				width = "double",
				set = function(info,val) cdalarm_proclaim_buff[1]=val end,
				get = function() return cdalarm_proclaim_buff[1] end
				},
			buffdefault = {
				name = "set to defaults",
				desc = "set the message to the defaults",
				order=1132, type = "execute",
				func = function(info,val) cdalarm_proclaim_buff[1]=cdalarm_proclaim_buff_default end,
				},
			buff2 = {
				name = "inactive message",
				desc = "this message is shown when a buff becomes inactive",
				order=1133, type = "input", multiline = false,
				width = "double",
				set = function(info,val) cdalarm_proclaim_buff[2]=val end,
				get = function() return cdalarm_proclaim_buff[2] end
				},
			buff2default = {
				name = "set to defaults",
				desc = "set the message to the defaults",
				order=1134, type = "execute",
				func = function(info,val) cdalarm_proclaim_buff[2]=cdalarm_proclaim_buff2_default end,
				},
			buffspace = {name ="\n\n", type = "description", order=1135},
				
			selfbuffheader = {name = "Buffs without a target (selfbuffs)", type="header", order=1140},
			selfbuff = {
				name = "active message",
				desc = "this message is shown when a buff becomes active/inactive",
				order=1141, type = "input", multiline = false,
				width = "double",
				set = function(info,val) cdalarm_proclaim_selfbuff[1]=val end,
				get = function() return cdalarm_proclaim_selfbuff[1] end
				},
			selfbuffdefault = {
				name = "set to defaults",
				desc = "set the message to the defaults",
				order=1142, type = "execute",
				func = function(info,val) cdalarm_proclaim_selfbuff[1]=cdalarm_proclaim_selfbuff_default end,
				},
			selfbuff2 = {
				name = "inactive message",
				desc = "this message is shown when a buff becomes active/inactive",
				order=1143, type = "input", multiline = false,
				width = "double",
				set = function(info,val) cdalarm_proclaim_selfbuff[2]=val end,
				get = function() return cdalarm_proclaim_selfbuff[2] end
				},
			selfbuff2default = {
				name = "set to defaults",
				desc = "set the message to the defaults",
				order=1144, type = "execute",
				func = function(info,val) cdalarm_proclaim_selfbuff[2]=cdalarm_proclaim_selfbuff2_default end,
				},
			selfbuffspace = {name ="\n\n", type = "description", order=1145},
				
			grpbuffheader = {name = "Buffs without multiple targets (groupbuffs)", type="header", order=1150},
			grpbuff = {
				name = "active message",
				desc = "this message is shown when a buff becomes active/inactive",
				order=1151, type = "input", multiline = false,
				width = "double",
				set = function(info,val) cdalarm_proclaim_grpbuff[1]=val end,
				get = function() return cdalarm_proclaim_grpbuff[1] end
				},
			grpbuffdefault = {
				name = "set to defaults",
				desc = "set the message to the defaults",
				order=1152, type = "execute",
				func = function(info,val) cdalarm_proclaim_grpbuff[1]=cdalarm_proclaim_grpbuff_default end,
				},
			grpbuff2 = {
				name = "inactive message",
				desc = "this message is shown when a buff becomes active/inactive",
				order=1153, type = "input", multiline = false,
				width = "double",
				set = function(info,val) cdalarm_proclaim_grpbuff[2]=val end,
				get = function() return cdalarm_proclaim_grpbuff[2] end
				},
			grpbuff2default = {
				name = "set to defaults",
				desc = "set the message to the defaults",
				order=1154, type = "execute",
				func = function(info,val) cdalarm_proclaim_grpbuff[2]=cdalarm_proclaim_grpbuff2_default end,
				},
			grpbuffspace = {name ="\n\n", type = "description", order=1155},
				
			instantheader = {name = "Casts with a target", type="header", order=1160},
			instant = {
				name = "Message",
				desc = "this message is shown when a spell becomes active/inactive",
				order=1161, type = "input", multiline = false,
				width = "double",
				set = function(info,val) cdalarm_proclaim_instant=val end,
				get = function() return cdalarm_proclaim_instant end
				},
			instantdefault = {
				name = "set to defaults",
				desc = "set the message to the defaults",
				order=1162, type = "execute",
				func = function(info,val) cdalarm_proclaim_instant=cdalarm_proclaim_instant_default end,
				},
			instantspace = {name ="\n\n", type = "description", order=1163},
				
			instantselfheader = {name = "Casts without a target", type="header", order=1170},
			instantself = {
				name = "Message",
				desc = "this message is shown when a spell becomes active/inactive",
				order=1171, type = "input", multiline = false,
				width = "double",
				set = function(info,val) cdalarm_proclaim_instantself=val end,
				get = function() return cdalarm_proclaim_instantself end
				},
			instantselfdefault = {
				name = "set to defaults",
				desc = "set the message to the defaults",
				order=1172, type = "execute",
				func = function(info,val) cdalarm_proclaim_instantself=cdalarm_proclaim_instantself_default end,
				},
			instantselfspace = {name ="\n\n", type = "description", order=1173},
				
			statusheader = {name = "{status} messages", type="header", order=1180},
			activeself = {
				name = "{status} active",
				desc = "this message is shown when a spell becomes active/inactive",
				order=1181, type = "input", multiline = false,
				set = function(info,val) cdalarm_proclaim_text_status[1]=val end,
				get = function() return cdalarm_proclaim_text_status[1] end
				},
			activedefault = {
				name = "set to defaults",
				desc = "set the message to the defaults",
				order=1182, type = "execute",
				func = function(info,val) cdalarm_proclaim_text_status[1]=cdalarm_proclaim_text_status_default[1] end,
				},
			statusspace = {name ="\n", type = "description", order=1183},
				
			inactiveself = {
				name = "{status} inactive",
				desc = "this message is shown when a spell becomes active/inactive",
				order=1184, type = "input", multiline = false,
				set = function(info,val) cdalarm_proclaim_text_status[2]=val end,
				get = function() return cdalarm_proclaim_text_status[2] end
				},
			inactivedefault = {
				name = "set to defaults",
				desc = "set the message to the defaults",
				order=1185, type = "execute",
				func = function(info,val) cdalarm_proclaim_text_status[2]=cdalarm_proclaim_text_status_default[2] end,
				},
			}
		}
end

function cdalarm_dec2hex(r,g,b)
	if r == nil then r = 0 end
	if g == nil then g = 0 end
	if b == nil then b = 0 end
    return string.format("%02x%02x%02x", r*250, g*250, b*250)
end