--Colorize proclaim
function cdalarm_colorize_class(msg, caster, class)
	local returnvalue =""
	if class == nil or class =="" then
		if caster then	class = select(2, UnitClass(caster))
		else			class = select(2, UnitClass(msg)) end
	end
	if class == "DEATHKNIGHT" then returnvalue="|CFF"..cdalarm_proclaim_classcolor[1]..msg.."|r"
	elseif class == "DRUID" then returnvalue="|CFF"..cdalarm_proclaim_classcolor[2]..msg.."|r"
	elseif class == "HUNTER" then returnvalue="|CFF"..cdalarm_proclaim_classcolor[3]..msg.."|r"
	elseif class == "MAGE" then returnvalue="|CFF"..cdalarm_proclaim_classcolor[4]..msg.."|r"
	elseif class == "PALADIN" then returnvalue="|CFF"..cdalarm_proclaim_classcolor[5]..msg.."|r"
	elseif class == "PRIEST" then returnvalue="|CFF"..cdalarm_proclaim_classcolor[6]..msg.."|r"
	elseif class == "ROGUE" then returnvalue="|CFF"..cdalarm_proclaim_classcolor[7]..msg.."|r"
	elseif class == "SHAMAN" then returnvalue="|CFF"..cdalarm_proclaim_classcolor[8]..msg.."|r"
	elseif class == "WARLOCK" then returnvalue="|CFF"..cdalarm_proclaim_classcolor[9]..msg.."|r"
	elseif class == "WARRIOR" then returnvalue="|CFF"..cdalarm_proclaim_classcolor[10]..msg.."|r"
	elseif class == "MONK" then returnvalue="|CFF"..cdalarm_proclaim_classcolor[11]..msg.."|r"
	else returnvalue=msg
	end

	return returnvalue
end

function cdalarm_colorize_status(statustext, status)
	local returnvalue = ""
	if status then returnvalue="|CFF"..cdalarm_proclaim_text_status_color[1][1]..""..statustext.."|r"
	else	 returnvalue="|CFF"..cdalarm_proclaim_text_status_color[2][1]..statustext.."|r" end
	return returnvalue
end

function cdalarm_colorize_specific(msg, sub)
	return "|CFF"..cdalarm_proclaim_constant_colors[sub][1]..msg.."|r"
end


--Proclaim functions
function cdalarm_spellcheck(auraID, player, eventchar)
	local returnvalue = ""
	playerrole = cdalarm_getplayerrole(player)
	auratocheck=""..auraID

	--overflow check - check data
	local currenttime = time()
	if auratocheck==cdalarm_last_spell_id and cdalarm_last_spell_timestamp+1>=currenttime then
		if eventchar == "SPELL_CAST_SUCCESS" and cdalarm_last_spell_event == "SPELL_CAST_SUCCESS" then returnvalue = "dejavue"
		elseif eventchar == "SPELL_CAST_SUCCESS" and cdalarm_last_spell_event == "SPELL_AURA_APPLIED" then returnvalue = "dejavue"
		elseif eventchar == "SPELL_AURA_APPLIED" and cdalarm_last_spell_event == "SPELL_CAST_SUCCESS" then returnvalue = "dejavue"
		elseif eventchar == "SPELL_AURA_APPLIED" and cdalarm_last_spell_event == "SPELL_AURA_APPLIED" then returnvalue = "dejavue"
		elseif eventchar == "SPELL_AURA_REMOVED" and cdalarm_last_spell_event == "SPELL_AURA_REMOVED" then returnvalue = "dejavue"
		end
	end
	
	if eventchar == "SPELL_AURA_APPLIED" or eventchar == "SPELL_AURA_REMOVED" then
		--check in selfbuffs
		if returnvalue == "" then
			for i=1,#cdalarm_selfbuffs do
				if(auratocheck == cdalarm_selfbuffs[i][1] and cdalarm_selfbuffs[i][playerrole+1]) then	returnvalue="selfbuff" end
			end
		end
	
		--check in buffs
		if returnvalue == "" then
			for i=1,#cdalarm_buffs do 
				if(auratocheck == cdalarm_buffs[i][1] and cdalarm_buffs[i][playerrole+1]) then returnvalue="buff" end
			end
		end
	
		--check in grpbuffs
		if returnvalue == "" then
			for i=1,#cdalarm_grpbuffs do 
				if(auratocheck == cdalarm_grpbuffs[i][1] and cdalarm_grpbuffs[i][playerrole+1]) then returnvalue="grpbuff" end
			end
		end
	
	elseif eventchar == "SPELL_CAST_SUCCESS" then
		--check in instants
		if returnvalue == "" then
			for i=1,#cdalarm_instants do 
				if(auratocheck == cdalarm_instants[i][1] and cdalarm_instants[i][playerrole+1]) then returnvalue="instant" end
			end
		end
	
		--check in instantsself
		if returnvalue == "" then
			for i=1,#cdalarm_instantsself do 
				if(auratocheck == cdalarm_instantsself[i][1] and cdalarm_instantsself[i][playerrole+1]) then returnvalue="instantself" end
			end
		end
	end
	--overflow check - update data
	if returnvalue ~= "" and returnvalue ~= "dejavue" then
		cdalarm_last_spell_id = auratocheck
		cdalarm_last_spell_timestamp = currenttime
		cdalarm_last_spell_event = eventchar
	end
	return returnvalue
end

local cdalarm_printouts = {false, false}

function cdalarm_check_fulltext()
	local currenttime = time()
	local framedata
	local rank = {0}
	if #cdalarm_proclaim_timestamps~= 0 then
		for i=1, #cdalarm_proclaim_texts do
			if cdalarm_proclaim_timestamps[i] ~= nil then
				framedata = cdalarm_proclaim_texts[i]
				if cdalarm_proclaim_timestamps[i]+cdalarm_times[2]+cdalarm_times[1]+0.5 <= currenttime then
					framedata[1]:Hide()
					table.remove(cdalarm_proclaim_timestamps, i)
					table.remove(cdalarm_proclaim_texts, i)
					if not(cdalarm_frame_allow_scrolling) then
						local place=framedata[4]
						cdalarm_printouts[place]=false
					end
				elseif cdalarm_proclaim_timestamps[i]+cdalarm_times[1] < currenttime and cdalarm_proclaim_timestamps[i]+cdalarm_times[1]+cdalarm_times[2]+0.5 > currenttime and cdalarm_proclaim_vanish and not(framedata[3]) then
					if cdalarm_frame_allow_scrolling then
						framedata[2]:SetPoint("TOPLEFT", cdalarm_frame_bg, "TOPLEFT" , cdalarm_frame_proclaim_xvalue, (-cdalarm_frame_proclaim_spacing*(#rank+1))+cdalarm_frame_proclaim_yvalue)
					else
						if framedata[4]==nil then
							local place = 1
							for i=1,#cdalarm_printouts+1 do
								if place == 1 and not(cdalarm_printouts[i]) then place = i end
							end
							cdalarm_printouts[place] = true
							framedata[4] = place
							framedata[2]:SetPoint("TOPLEFT", cdalarm_frame_bg, "TOPLEFT" , cdalarm_frame_proclaim_xvalue, (-cdalarm_frame_proclaim_spacing*place)+cdalarm_frame_proclaim_yvalue)
						end
					end
					UIFrameFadeOut(framedata[1], cdalarm_times[2], 1, 0)
					framedata[3] = true
					rank[#rank+1] = i
				else
					if cdalarm_frame_allow_scrolling then
						framedata[2]:SetPoint("TOPLEFT", cdalarm_frame_bg, "TOPLEFT" , cdalarm_frame_proclaim_xvalue, (-cdalarm_frame_proclaim_spacing*(#rank+1))+cdalarm_frame_proclaim_yvalue)
					else
						if framedata[4]==nil then
							local place = 1
							for i=1,#cdalarm_printouts+1 do
								if place == 1 and not(cdalarm_printouts[i]) then place = i end
							end
							cdalarm_printouts[place] = true
							framedata[4] = place
							framedata[2]:SetPoint("TOPLEFT", cdalarm_frame_bg, "TOPLEFT" , cdalarm_frame_proclaim_xvalue, (-cdalarm_frame_proclaim_spacing*place)+cdalarm_frame_proclaim_yvalue)
						end
					end
					framedata[1]:Show()
					rank[#rank+1] = i
				end
			end
		end
	end
	
	if cdalarm_frame_allow_scrolling then
		if #rank>cdalarm_max_events+1 then
			for i=1, #rank-cdalarm_max_events-1 do
				framedata = cdalarm_proclaim_texts[rank[i+1]]
				framedata[1]:Hide()
				table.remove(cdalarm_proclaim_timestamps, rank[i+1])
				table.remove(cdalarm_proclaim_texts, rank[i+1])
			end
			cdalarm_check_fulltext()
		end
	end
	
	if cdalarm_lock then
		cdalarm_frame_bg:SetMovable(false)
		cdalarm_frame_bg:EnableMouse(false)
	end
end

function cdalarm_generate_fulltext(msg, status)
	local currenttime = time()
	local insert = {}
	local newmsgframe = CreateFrame("Frame", "cdalarm_proclaim_textframe", cdalarm_frame_bg)
		newmsgframe.name = "cdalarm_proclaim_textframe"
		newmsgframe.parent = cdalarm_frame_bg
	local newmsg = newmsgframe:CreateFontString(nil, "ARTWORK", "GameFontNormal")
		newmsg:SetPoint("TOPLEFT", cdalarm_frame_bg, "TOPLEFT" , 20, -3000)
		if status then 	newmsg:SetTextColor(cdalarm_text_color[1][1], cdalarm_text_color[1][2], cdalarm_text_color[1][3], cdalarm_text_color[1][4])
		else 			newmsg:SetTextColor(cdalarm_text_color[2][1], cdalarm_text_color[2][2], cdalarm_text_color[2][3], cdalarm_text_color[2][4]) end
		newmsg:SetFont(cdalarm.LSM:Fetch("font", cdalarm_frame_font), cdalarm_frame_fontsize)	
		newmsg:SetJustifyH(cdalarm_frame_font_align)
		newmsg:SetWidth(cdalarm_frame_width-cdalarm_frame_proclaim_xvalue)
		newmsg:SetText(msg)	
		newmsgframe:Hide()
	insert[1] = newmsgframe
	insert[2] = newmsg
	insert[3] = false
		
	table.insert(cdalarm_proclaim_timestamps, #cdalarm_proclaim_timestamps+1, currenttime)
	table.insert(cdalarm_proclaim_texts, #cdalarm_proclaim_texts+1, insert)
end

function cdalarm_generate_singlealarm(alarmtype, spell, caster, target, status)
	local customalarm = ""
	--load custom alarm text
	if alarmtype == "buff" 			and status 		then customalarm = cdalarm_proclaim_buff[1]
	elseif alarmtype == "buff" 		and not(status) then customalarm = cdalarm_proclaim_buff[2]
	elseif alarmtype == "selfbuff"	and status  	then customalarm = cdalarm_proclaim_selfbuff[1]
	elseif alarmtype == "selfbuff"	and not(status) then customalarm = cdalarm_proclaim_selfbuff[2]
	elseif alarmtype == "grpbuff"	and status 		then customalarm = cdalarm_proclaim_grpbuff[1]
	elseif alarmtype == "grpbuff"	and not(status) then customalarm = cdalarm_proclaim_grpbuff[2]
	elseif alarmtype == "instant" 					then customalarm = cdalarm_proclaim_instant
	elseif alarmtype == "instantself" 				then customalarm = cdalarm_proclaim_instantself
	end
	
	--load custom status msg
	if status then statustext=cdalarm_proclaim_text_status[1]
	else statustext=cdalarm_proclaim_text_status[2] end
	-- change [spell]
	if spell ~= nil then
		customalarm = string.gsub(customalarm, "{spell}", spell)
		customalarm = string.gsub(customalarm, "{spell_sc}", cdalarm_colorize_specific(spell, 3))
		customalarm = string.gsub(customalarm, "{spell_cc}", cdalarm_colorize_class(spell, caster))
	end
	
	-- change [caster]
	if caster ~= nil then
		customalarm = string.gsub(customalarm, "{caster}", caster)
		customalarm = string.gsub(customalarm, "{caster_sc}", cdalarm_colorize_specific(caster, 1))
		customalarm = string.gsub(customalarm, "{caster_cc}", cdalarm_colorize_class(caster))
	end
	
	-- change [target]
	if target ~= nil then
		customalarm = string.gsub(customalarm, "{target}", target)
		customalarm = string.gsub(customalarm, "{target_sc}", cdalarm_colorize_specific(target, 2))
		customalarm = string.gsub(customalarm, "{target_cc}", cdalarm_colorize_class(target))
	end
	
	-- change [statustext]
	if statustext ~= nil then
		customalarm = string.gsub(customalarm, "{status}", statustext)
		customalarm = string.gsub(customalarm, "{status_sc}", cdalarm_colorize_status(statustext, status))
		customalarm = string.gsub(customalarm, "{status_cc}", cdalarm_colorize_status(statustext, status))
	end
	return customalarm
end

function cdalarm_getplayerrole(player)
	local returnvalue = 4
	if player ~= nil then
		local role = UnitGroupRolesAssigned(player);
		
		if role == "DAMAGER" then returnvalue = 3
		elseif role == "HEALER" then returnvalue = 2
		elseif role == "TANK" then returnvalue = 1
		else returnvalue = 4
		end
	end
	return returnvalue
end

function cdalarm_proclaim(alarmtype, spell, caster, target, status)
	msg = cdalarm_generate_singlealarm(alarmtype, spell, caster, target, status)
	if msg~="" then cdalarm_generate_fulltext(msg, status) end
	cdalarm_check_fulltext()
	cdalarm_print_variable(cdalarm_frame_bg:IsShown(),"cdalarm_frame_bg:IsShown()")
	if cdalarm_allow_sounds and msg~="" and cdalarm_frame_bg:IsShown() then
		if status then 	PlaySoundFile(cdalarm_sounds2play[1][1], cdalarm_sounds2play[1][2])
		else 			PlaySoundFile(cdalarm_sounds2play[2][1], cdalarm_sounds2play[2][2])
		end
	end
	
end
