--Slash Command
SLASH_CDALARM1 = "/cdalarm"


--UI Functions
function SlashCmdList.CDALARM(msg, editbox)
	if msg == "reset" then
		cdalarm_frame_bg:SetPoint("TOPLEFT", 600, -300)
		print("|CFFFF7D0ACDAlarm|r - frame has been reset")
	elseif msg == "options" then
		InterfaceOptionsFrame_OpenToCategory(cdalarm.optionpanel_spells);
		print("|CFFFF7D0ACDAlarm|r - option frame opened")
	elseif msg == "print" then cdalarm_print_variables()
	elseif msg == "print spells" then cdalarm_print_variables_spells()
	elseif msg == "defaults" then
		print("|CFFFF7D0ACDAlarm|r - defaults loaded")
		cdalarm_load_variables(true)
	elseif msg == "enable" then
		if cdalarm_show then 	cdalarm_show=false cdalarm_checkshow(false) print("|CFFFF7D0ACDAlarm|r - Addon disabled")
		else 					cdalarm_show=true  cdalarm_checkshow(true) 	print("|CFFFF7D0ACDAlarm|r - Addon enabled") end
	else
		print ("|CFFFF7D0ACDAlarm|r cmd list")
		print ("|CFFFF7D0A/cdalarm|r reset - resets the frameposition")
		print ("|CFFFF7D0A/cdalarm|r options - opens the option frame")
		print ("|CFFFF7D0A/cdalarm|r defaults - resets the addon to defaults")
		print ("|CFFFF7D0A/cdalarm|r enable - enables/disables the addon")
	end
end

function cdalarm_checkshow()
	if cdalarm_show then
		if cdalarm_showonlyinfight and cdalarm_infight then cdalarm_frame_bg:Show()
		elseif cdalarm_showonlyinfight and not(cdalarm_infight) then cdalarm_frame_bg:Hide()
		else cdalarm_frame_bg:Show() end
	else cdalarm_frame_bg:Hide() end
end

function cdalarm_setsound()
	cdalarm_sounds2play[1][1] = cdalarm.LSM:Fetch("sound", cdalarm_sounds[1][1])
	cdalarm_sounds2play[1][2] = cdalarm_sounds[1][2]
	cdalarm_sounds2play[2][1] = cdalarm.LSM:Fetch("sound", cdalarm_sounds[2][1])
	cdalarm_sounds2play[2][2] = cdalarm_sounds[2][2]
end

function cdalarm_change_frame_bg()
	cdalarm_frame_bg:SetBackdrop({bgFile=cdalarm.LSM:Fetch("background", cdalarm_texture_bg),
												edgeFile=cdalarm.LSM:Fetch("border", cdalarm_edge_texture),
												tile=cdalarm_tile,
												tilesize=cdalarm_tile_size,
												edgesize=cdalarm_edge_size,
												insets={left=cdalarm_texture_insets[1],
													right=cdalarm_texture_insets[2],
													top=cdalarm_texture_insets[3],
													bottom=cdalarm_texture_insets[4]}})
	cdalarm_frame_bg:SetBackdropColor(cdalarm_backdrop_color[1],cdalarm_backdrop_color[2],cdalarm_backdrop_color[3],cdalarm_backdrop_color[4])
	 								
end

function cdalarm_textframe_template(text, fontsize, parent, color, xvalue, yvalue, align)
	local returnvalue
	if fontsize == ""	then	fontsize = "GameFontNormal" end
	returnvalue = parent:CreateFontString(nil, "ARTWORK", fontsize)
	returnvalue:SetPoint("TOPLEFT", parent, "TOPLEFT" , xvalue, yvalue)
	returnvalue:SetTextColor(color[1], color[2], color[3], color[4])
	returnvalue:SetText(text)	
	returnvalue:SetJustifyH(align)
	return returnvalue
end

function cdalarm_button_template(text, name, template, parent, xvalue, yvalue, width, height)
	local returnvalue
	if template == ""	then	template = "UIPanelButtonTemplate" end
	returnvalue = CreateFrame("Button", name, parent, template)
	returnvalue:SetWidth(width)
	returnvalue:SetHeight(height)
	returnvalue:SetPoint("TOPLEFT", parent, "TOPLEFT", xvalue, yvalue)
	returnvalue:SetText(text)
	return returnvalue
end

function cdalarm_editbox_template(text, name, template, parent, xvalue, yvalue, width, height, multiline)
	local returnvalue
	if template == ""	then	template = "InputBoxTemplate" end
	returnvalue = CreateFrame("EditBox", name, parent, template)
	returnvalue:SetHeight(height)
	returnvalue:SetWidth(width)
	returnvalue:SetText(text)
	returnvalue:SetPoint("TOPLEFT", parent, "TOPLEFT", xvalue, yvalue)
	returnvalue:SetMaxLetters(255)
	returnvalue:SetMultiLine(multiline)
	returnvalue:SetCursorPosition(0)
	returnvalue:SetAutoFocus(false)
	returnvalue:SetTextInsets(0, 0, 0, 0)
	return returnvalue
end

function cdalarm_checkbox_template(name, tooltip, template, parent, xvalue, yvalue, width, height)
	local returnvalue
	if template == ""	then	template = "ChatConfigCheckButtonTemplate" end
	returnvalue = CreateFrame("CheckButton", name, parent, template)
	returnvalue:SetWidth(width)
	returnvalue:SetHeight(height)
	returnvalue:SetHitRectInsets(0, 0, 0, 0);
	returnvalue.tooltip = tooltip
	returnvalue:SetPoint("TOPLEFT", parent, "TOPLEFT", xvalue, yvalue)
	return returnvalue
end

function cdalarm_slider_template(name, template, parent, xvalue, yvalue, width, height, minvalue, maxvalue, value, text)
	local returnvalue
	if template == ""	then	template = "OptionsSliderTemplate" end
	returnvalue = CreateFrame("Slider", name, parent, template)
	returnvalue:SetWidth(width)
	returnvalue:SetHeight(height)
	returnvalue:SetPoint("TOPLEFT", parent, "TOPLEFT", xvalue, yvalue)
	getglobal(returnvalue:GetName() .. "Low"):SetText(minvalue)
	getglobal(returnvalue:GetName() .. "High"):SetText(maxvalue)
	getglobal(returnvalue:GetName() .. "Text"):SetText(text)
	returnvalue:SetMinMaxValues(minvalue, maxvalue)
	returnvalue:SetValue(value)
	returnvalue:Show()
	return returnvalue
end